﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim pnlEditTools As Panel
	Dim scvEdit As ScrollView
	Dim btnEditAdd, btnEditModif, btnEditMove As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Edit")
	Activity.Title = Main.ProgName & " : Edit"

	If Activity.Width < Activity.Height Then
		pnlEditTools.Top = Activity.Height - pnlEditTools.Height
		scvEdit.Height = pnlEditTools.Top
		scvEdit.Panel.Height = (Main.NumberOfColumns - 1) * Main.THeight + 100%y - pnlEditTools.Height - 10dip
	Else
		pnlEditTools.Left = Activity.Width - pnlEditTools.Width
		scvEdit.Height = Activity.Height
		scvEdit.Panel.Height = (Main.NumberOfColumns - 1) * Main.THeight + 100%y
	End If

	scvEdit.Panel.Color = Colors.RGB(0,96,0)
End Sub

Sub Activity_Resume
	Dim i As Int
	
	For i = 0 To Main.NumberOfColumns - 1
		Dim l As Label
		Dim e As EditText
		l.Initialize("")
		scvEdit.Panel.AddView(l, 10dip, i * Main.THeight, scvEdit.Width - 20dip,Main.LHeight)
		l.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
		l.Tag = i
		l.TextColor = Colors.Yellow
		l.Text = Main.ColumnName(l.Tag)
		e.Initialize("edtEdit")
		scvEdit.Panel.AddView(e, 5dip, i * Main.THeight + Main.LHeight, scvEdit.Width - 10dip,Main.EHeight)
		e.Gravity = Gravity.LEFT
		e.Tag = i
		If i = 0 Then
			e.Enabled = False
		End If
	Next

	If Main.NumberOfRows > 0 Then
		EditDispItem(Main.SelectedRow)
	Else
		For i = 0 To Main.NumberOfColumns - 1
			Dim e As EditText
			e = scvEdit.Panel.GetView(i * 2 + 1)
			e.Text = ""
		Next
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnEditAdd_Click
	Dim row(Main.NumberOfColumns) As String
	Dim i, hh As Int
	Dim txt As String
	
	txt = "SELECT max(" & Main.ColumnName(0) & ") FROM " & Main.DBTableName
	row(0) = Main.SQL1.ExecQuerySingleResult(txt) + 1

	txt = "INSERT INTO " & Main.DBTableName & " VALUES (NULL"
	For i = 1 To Main.NumberOfColumns - 1
		Dim e As EditText
		e = scvEdit.Panel.GetView(i * 2 + 1)
		row(e.Tag) = e.Text
		txt = txt&" , '"&e.Text&"'"
		If e.Text = "" Then
			hh = hh + 1
		End If
	Next
	txt = txt & ")"
	
	If hh > 0 Then
		Msgbox("There are " & hh & " data missing ","Attention")
		Return
	End If

	If Main.NumberOfRows > 0 Then
		btnEditModif.Visible = True
	End If
	Main.RowID.Add(row(0))
	Main.SQL1.ExecNonQuery(txt)
End Sub

Sub btnEditModif_Click
	Dim row(Main.NumberOfColumns) As String
	Dim i As Int
	Dim txt As String

	For i = 0 To Main.NumberOfColumns - 1
		Dim e As EditText
		e = scvEdit.Panel.GetView(i * 2 + 1)
		row(e.Tag) = e.Text
	Next
	
	txt = "UPDATE " & Main.DBTableName & " Set " & Main.ColumnName(0) & " = '" & row(0)
	For i = 1 To Main.NumberOfColumns - 1
		txt = txt & "', "&Main.ColumnName(i) & " = '" & row(i)
	Next 
	txt = txt & "' WHERE " & Main.ColumnName(0) & " = '" & Main.SelectedID & "'"
	Main.SQL1.ExecNonQuery(txt)
End Sub

Sub EditDispItem(Row As Int)
	Dim Cursor1 As Cursor
	Dim i As Int
	Dim txt As String
	
	txt = "SELECT * FROM " & Main.DBTableName & " WHERE " & Main.ColumnName(0) & " = " & Main.RowID.Get(Row)
	Cursor1 = Main.SQL1.ExecQuery(txt)
	Cursor1.Position = 0
	For i = 0 To Main.NumberOfColumns - 1
		Dim e As EditText
		e = scvEdit.Panel.GetView(i * 2 + 1)
		e.Text = Cursor1.GetString(Main.ColumnName(e.Tag))
	Next
End Sub

Sub edtEdit_FocusChanged(HasFocus As Boolean)
	Dim edt As EditText
	
	If HasFocus = True Then
		edt = Sender
		scvEdit.ScrollPosition = edt.Top - 40dip
	End If
End Sub

Sub btnEditMove_Click
	Dim rc As RowCol
	Dim i As Int
	
	If btnEditMove.IsInitialized Then
		btnEditMove.Visible = True	' sets the previous button visible to true
	End If
	
	btnEditMove = Sender					' remembers the current used button
	
	i = Main.SelectedRow
	
	Select btnEditMove.Tag
	Case "EditPrev" 
		i = i - 1
		If i = 0 Then
			btnEditMove.Visible = False
		End If
	Case "EditNext"
		i = i + 1
		If i = Main.NumberOfRows - 1 Then
			btnEditMove.Visible = False
		End If
	End Select
	rc.Row = i

	Main.SelectedRow = rc.Row
	EditDispItem(Main.SelectedRow)
End Sub

Sub btnEditMove_LongClick
	Dim rc As RowCol
	Dim i As Int
	
	If btnEditMove.IsInitialized Then
		btnEditMove.Visible = True	' sets the previous button visible to true
	End If
	
	btnEditMove = Sender					' remembers the current used button
	
	Select btnEditMove.Tag
	Case "EditPrev" 
		btnEditMove.Visible = False
		i = 0
	Case "EditNext"
		btnEditMove.Visible = False
		i = Main.NumberOfRows - 1
	End Select
	rc.Col = 0
	rc.Row = i
	
	EditDispItem(Main.SelectedRow)
End Sub