﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim pnlFilterTools As Panel
	Dim scvFilter As ScrollView
	Dim btnFilterGo, btnFilterAND, btnFilterOR As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Filter")
	Activity.Color = Colors.RGB(0,0,128)
	Activity.Title = Main.ProgName & " : Filter" 
	
	If Activity.Width < Activity.Height Then
		pnlFilterTools.Top =  Activity.Height - pnlFilterTools.Height
		scvFilter.Height = Activity.Height - pnlFilterTools.Height
	Else
		pnlFilterTools.Left = Activity.Width - pnlFilterTools.Width
		scvFilter.Height = Activity.Height
		scvFilter.Width = Activity.Width - pnlFilterTools.Width
	End If
	
	scvFilter.Panel.Height = (Main.NumberOfColumns - 1) * Main.THeight
	scvFilter.Panel.Color = Colors.RGB(0,0,128)
End Sub

Sub Activity_Resume
	Dim i, j As Int
	
	For i = 1 To Main.NumberOfColumns - 1
		Dim l As Label
		Dim spn As Spinner
		l.Initialize("")
		scvFilter.Panel.AddView(l, 10dip, (i - 1) * Main.THeight, scvFilter.Width - 20dip, Main.LHeight)
		l.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
		l.Tag = i
		l.TextColor = Colors.Yellow
		l.Text = Main.ColumnName(l.Tag)
		spn.Initialize("spnFilter")
		scvFilter.Panel.AddView(spn, 5dip, (i - 1) * Main.THeight + Main.LHeight, scvFilter.Width - 10dip, Main.EHeight)
		spn.Tag = i
		Dim Curs As Cursor
		Dim txt As String
		txt = "SELECT DISTINCT " & Main.ColumnName(i) & " FROM " & Main.DBTableName & " ORDER BY " & Main.ColumnName(i) & " ASC"
		Curs = Main.SQL1.ExecQuery(txt)
		spn.Clear
		spn.Add("ALL")
		For j = 0 To Curs.RowCount - 1
			Curs.Position = j
			spn.Add(Curs.GetString(Main.ColumnName(i)))
		Next
		spn.SelectedIndex = Main.FilterCriteriaID.Get(i)
	Next

	' stes the column sort orientation to ASC 
	For i = 0 To Main.NumberOfColumns - 1
		Main.SortDirection(i) = "ASC"
	Next
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnFilterGo_Click
	Main.Filtered = True
	Main.SelectedRow = -1
	Activity.Finish
End Sub

Sub btnFilterAND_Click
	btnFilterOR.TextColor = Colors.Red
	Main.FilterType = "AND"
	btnFilterAND.TextColor = Colors.RGB(0,255,0)
End Sub

Sub btnFilterOR_Click
	btnFilterAND.TextColor = Colors.Red
	Main.FilterType = "OR"
	btnFilterOR.TextColor = Colors.RGB(0,255,0)
End Sub

Sub btnFilterClearAll_Click
	Dim i As Int
	
	For i = 0 To Main.NumberOfColumns - 2
		Dim spn As Spinner
		spn = scvFilter.Panel.GetView(i * 2 + 1)
		spn.SelectedIndex = 0
	Next
End Sub

Sub spnFilter_ItemClick (Position As Int, Value As Object)
	Dim spn As Spinner
	
	spn = Sender
	Main.FilterCriteria.Set(spn.Tag, Value)
	Main.FilterCriteriaID.Set(spn.Tag, Position)
End Sub